package labone;

import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;

/**
 * Created by IntelliJ IDEA.
 * User: zaic
 * Date: 3/21/12
 * Time: 3:18 PM
 */
public class PlotPanel extends JPanel {
    BufferedImage img_lena;
    boolean blend = false;
    boolean filter = false;
    int animation = -1;
    DynamicImageDrawer animation_drawer = null;
    
    @Override
    public void paint(Graphics g) {
        super.paint(g);
        if(img_lena == null) return ;
        if(animation == -1) {
            StaticImageDrawer.draw(this, (Graphics2D)g, img_lena, blend, filter);
        } else {
            if(animation_drawer == null)
                animation_drawer = new DynamicImageDrawer(this, img_lena, blend, filter);
            animation_drawer.draw((Graphics2D)g, (double)animation / Window.iteration_count);
        }
    }
    
    void setImage(BufferedImage img) {
        img_lena = img;
    }

    void setBlend(boolean value) {
        blend = value;
        if(animation_drawer != null)
            animation_drawer.setBlend(value);
    }

    void setFilter(boolean value) {
        filter = value;
        if(animation_drawer != null)
            animation_drawer.setFilter(value);
    }

    void setAnimation(int value) {
        animation = value;
    }

    void dropAnimation() {
        animation = -1;
        animation_drawer = null;
    }
}
